; Acid boil (7.01.97)
; Written by EXeLENZ (55:55/2@generalnet, 2:5030/448.1@fidonet).
; Ivan Shagin IRL
; (me@exelenz.ru, ivan@solvo.ru)

; Send me a greeting if you will find this code useful.
;

.386

ASSUME CS:CODE_SEG,DS:DATA_SEG
CODE_SEG SEGMENT USE16 PARA PUBLIC "CODE"
   ORG 100H

;/*****************************************************************************
;| here i begin my litil proggy
;\*****************************************************************************
   acid PROC NEAR
      mov bx,0138h                     ; shrink prog mem block
      mov ah,4ah                       ;
      int 21h                          ;
      mov sp, 1086h                    ; move stack at end of new
      pusha                            ; memory pool
      push sp

      mov ax,0                         ; is mouse drv installed ?
      int 33h                          ;
      mov byte ptr [mouse_presence],al ;

      xor ax,ax                        ;
      mov al,13H                       ; standart 13H vga mode
      int 10H                          ;

      mov al,3                         ; get mouse position
      int 33h                          ;
      add cx,dx                        ;
      mov [mouse_state],cx             ;

      call _clear_screen
      call make_normalized_acid_pal    ; make palette

      mov al,0                         ;
      mov ah,48h                       ; allocate 64000 bytes.
      mov bx,0fa0h                     ; seg in ax.
      int 21h                          ;
      jnc memory_allocated_ok          ; exit if unsucsessful
      int 20h                          ;

memory_allocated_ok:
      mov image_adr,ax                 ; image adress at image_adr
      mov di,0                         ; fill image buffer
      push ds
      mov ds,ax                        ;
cont:                                  ;
      mov bx,di                        ;
      mov byte ptr [di],0              ;
      inc di                           ;
      cmp di,64000                     ;
      jb cont                          ;
      pop ds

      in eax, 40h                      ; X[j]
      mov [circle_rand_prev],eax       ; init PRNG

      mov cx,300
      mov bx,0
main_cycle:
      inc bx
      cmp bx,4
      jne no_bub
      call _random_bub
      mov bx,0
no_bub:
      call _random_dot
      call _smooth
      call _print_image_from_buffer

      call _exit_if_action
      cmp [exit_y_n],YES
      jne main_cycle

      xor ax,ax                        ;
      mov al,3                         ; standart text mode
      int 10H                          ; (screen auto clears)

      mov ah,0eh                       ; write logo.
      xor bx,bx                        ;
      mov si,offset cs:message1        ;

wri:  mov al,[si]                      ;
      xor al,'E'
      inc si                           ;
      int 10h                          ;
      cmp al,255                       ;
      jne wri                          ;

      pop sp
      popa
      int 20H
   acid ENDP

   include include\equ.inc             ; EQU definitions
   include include\word.inc            ; get and put to (from) v/mem
   include include\smooth.inc          ; smoothing routine
   include include\service.inc         ; misc service routines
   include include\random.inc          ; random pix routine

CODE_SEG ENDS

DATA_SEG SEGMENT USE16 PARA PUBLIC 'DATA'
   message1 db 18,55,44,49,49,32,43,101,39,60,101,0,29,32,9,0,11,31,101,109,112,112,127,112,112,106,119,5,34,32,43,32,55,36,41,43,32,49,105,101,119,127,112,117,118,117,106,113,113,125,107,116,5,35,44,33,42,43,32,49,108,-70
   image_adr dw '..'                   ; adress of video buffer
   exit_y_n db '.'                     ; exit flag
   mouse_state dw '..'
   circle_rand_prev dd '....'
   mouse_presence db '.','.','.'
DATA_SEG ENDS

END acid



