; 'Acid boil' project :

; Random dots. Written by EXeLENZ (55:55/2@generalnet, 2:5030/448.1@fidonet).
; This is not even a beta version, it's a research :)

;/******************* N_DOTS random dots are drawn here  ********************\
;* Input  : image_adr - segment of pic                                       *
;* Output : None                                                             *
;\***************************************************************************/
            PUBLIC _random_dot
_random_dot PROC FAR
            push ds
            pusha
            mov ax,[image_adr]
            mov ds,ax                      ; Set ds to image

            mov cx,N_DOTS
            in eax, 40h
            mov esi,eax
            in eax, 40h
random_fill:                               ; X[j+1] = 0x015A4E35 * X[j] + 1
            mov ebx,015A4E35H
            mul ebx
            add eax,1
            mov di, ax

            cmp di,64000-640               ; if >640 & <64000-640,
            jae random_fill                ; then OK. else get other.
            cmp di,640                     ;
            jbe random_fill                ;


            xchg eax,esi                   ; color calculated
            xor bx,bx                      ;
            xor ax,ax                      ;
            mov bl,byte ptr [di-1]         ;
            add ax,bx                      ; random dot is colored as
            mov bl,byte ptr [di+1]         ; average of its neithbours
            add ax,bx                      ;
            mov bl,byte ptr [di-320]       ;
            add ax,bx                      ;
            mov bl,byte ptr [di+320]       ;
            add ax,bx                      ;
            shr ax,2                       ;

            cmp al,70                      ;
            ja need_no_add                 ;
            add al,73                      ; raise average brightness.
need_no_add:
            cmp al,230                     ;
            jb color_ok                    ;
            sub al,40                      ;

color_ok:   mov [di],al                    ;
            xchg eax,esi                   ;

            loop random_fill               ;

            popa
            pop ds
            ret
_random_dot ENDP

;/*********************** random bubble is drawn here  **********************\
;* Input  : image_adr - segment of pic                                       *
;* Output : None                                                             *
;\***************************************************************************/
            PUBLIC _random_bub
_random_bub PROC FAR
            push ds es
            pusha
            mov ax,[image_adr]
            mov ds,ax                      ; set ds to image

            mov di, cs:[offset circle_rand_prev]
            mov eax,cs:[di]
random_pos:
            mov ebx,015A4E35H              ; random position
            mul ebx                        ; X[j] in circle_rand_prev.
            add eax,1                      ;
            mov di, cs:[offset circle_rand_prev]
            mov cs:[di],eax                ;
            mov di, ax                     ;

            cmp di,64000-320*20            ; If >320 & <64000-320*20,
            jae random_pos                 ; then OK. Else get other.
            cmp di,640                     ;
            jbe random_pos                 ;

shift_more: shr eax,1                      ; size of 'bubble'
            cmp al,18                      ; also random.
            ja shift_more                  ; it must be 18 or less.
            cmp al,4                       ;
            ja bubble_is_big_enough        ;
            mov al,4                       ;
bubble_is_big_enough:                      ;

            xor bx,bx                      ;
            xor cx,cx                      ;
            mov cl,al                      ;
bubble_draw:                               ; here it is drawn
            mov [di+bx],bl                 ;
            inc bl                         ;
            cmp bl,al                      ;
            jne bubble_draw                ;
            add di,320                     ;
            mov bl,0                       ;
            loop bubble_draw               ;

            popa
            pop es ds
            ret
_random_bub ENDP


